81bd6f906ded6731a229544948d38ab91c095cfe
[blender.git] / build_files / cmake / platform / platform_apple_xcode.cmake
1 # ***** BEGIN GPL LICENSE BLOCK *****
2 #
3 # This program is free software; you can redistribute it and/or
4 # modify it under the terms of the GNU General Public License
5 # as published by the Free Software Foundation; either version 2
6 # of the License, or (at your option) any later version.
7 #
8 # This program is distributed in the hope that it will be useful,
9 # but WITHOUT ANY WARRANTY; without even the implied warranty of
10 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
11 # GNU General Public License for more details.
12 #
13 # You should have received a copy of the GNU General Public License
14 # along with this program; if not, write to the Free Software Foundation,
15 # Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
16 #
17 # The Original Code is Copyright (C) 2016, Blender Foundation
18 # All rights reserved.
19 # ***** END GPL LICENSE BLOCK *****
20
21 # Xcode and system configuration for Apple.
22
23 # require newer cmake on osx because of version handling,
24 # older cmake cannot handle 2 digit subversion!
25 cmake_minimum_required(VERSION 3.0.0)
26
27 if(NOT CMAKE_OSX_ARCHITECTURES)
28   set(CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING
29     "Choose the architecture you want to build Blender for: i386, x86_64 or ppc"
30     FORCE)
31 endif()
32
33 if(NOT DEFINED OSX_SYSTEM)
34   execute_process(
35       COMMAND xcodebuild -version -sdk macosx SDKVersion
36       OUTPUT_VARIABLE OSX_SYSTEM
37       OUTPUT_STRIP_TRAILING_WHITESPACE)
38 endif()
39
40 # workaround for incorrect cmake xcode lookup for developer previews - XCODE_VERSION does not
41 # take xcode-select path into account but would always look  into /Applications/Xcode.app
42 # while dev versions are named Xcode<version>-DP<preview_number>
43 execute_process(
44     COMMAND xcode-select --print-path
45     OUTPUT_VARIABLE XCODE_CHECK OUTPUT_STRIP_TRAILING_WHITESPACE)
46 string(REPLACE "/Contents/Developer" "" XCODE_BUNDLE ${XCODE_CHECK}) # truncate to bundlepath in any case
47
48 if(${CMAKE_GENERATOR} MATCHES "Xcode")
49
50   # earlier xcode has no bundled developer dir, no sense in getting xcode path from
51   if(${XCODE_VERSION} VERSION_GREATER 4.2)
52     # reduce to XCode name without dp extension
53     string(SUBSTRING "${XCODE_CHECK}" 14 6 DP_NAME)
54     if(${DP_NAME} MATCHES Xcode5)
55       set(XCODE_VERSION 5)
56     endif()
57   endif()
58
59   ##### cmake incompatibility with xcode  4.3 and higher #####
60   if(${XCODE_VERSION} MATCHES '') # cmake fails due looking for xcode in the wrong path, thus will be empty var
61     message(FATAL_ERROR "Xcode 4.3 and higher must be used with cmake 2.8-8 or higher")
62   endif()
63   ### end cmake incompatibility with xcode 4.3 and higher ###
64
65   if(${XCODE_VERSION} VERSION_EQUAL 4 OR ${XCODE_VERSION} VERSION_GREATER 4 AND ${XCODE_VERSION} VERSION_LESS 4.3)
66     # Xcode 4 defaults to the Apple LLVM Compiler.
67     # Override the default compiler selection because Blender only compiles with gcc up to xcode 4.2
68     set(CMAKE_XCODE_ATTRIBUTE_GCC_VERSION "com.apple.compilers.llvmgcc42")
69     message(STATUS "Setting compiler to: " ${CMAKE_XCODE_ATTRIBUTE_GCC_VERSION})
70   endif()
71 else() # unix makefile generator does not fill XCODE_VERSION var, so we get it with a command
72   execute_process(COMMAND xcodebuild -version OUTPUT_VARIABLE XCODE_VERS_BUILD_NR)
73   string(SUBSTRING "${XCODE_VERS_BUILD_NR}" 6 3 XCODE_VERSION) # truncate away build-nr
74   unset(XCODE_VERS_BUILD_NR)
75 endif()
76
77 message(STATUS "Detected OS X ${OSX_SYSTEM} and Xcode ${XCODE_VERSION} at ${XCODE_BUNDLE}")
78
79 if(${XCODE_VERSION} VERSION_LESS 4.3)
80   # use guaranteed existing sdk
81   set(CMAKE_OSX_SYSROOT /Developer/SDKs/MacOSX${OSX_SYSTEM}.sdk CACHE PATH "" FORCE)
82 else()
83   # note: xcode-select path could be ambiguous,
84   # cause /Applications/Xcode.app/Contents/Developer or /Applications/Xcode.app would be allowed
85   # so i use a selfcomposed bundlepath here
86   set(OSX_SYSROOT_PREFIX ${XCODE_BUNDLE}/Contents/Developer/Platforms/MacOSX.platform)
87   message(STATUS "OSX_SYSROOT_PREFIX: " ${OSX_SYSROOT_PREFIX})
88   set(OSX_DEVELOPER_PREFIX /Developer/SDKs/MacOSX${OSX_SYSTEM}.sdk) # use guaranteed existing sdk
89   set(CMAKE_OSX_SYSROOT ${OSX_SYSROOT_PREFIX}/${OSX_DEVELOPER_PREFIX} CACHE PATH "" FORCE)
90   if(${CMAKE_GENERATOR} MATCHES "Xcode")
91     # to silence sdk not found warning, just overrides CMAKE_OSX_SYSROOT
92     set(CMAKE_XCODE_ATTRIBUTE_SDKROOT macosx${OSX_SYSTEM})
93   endif()
94 endif()
95
96 if(OSX_SYSTEM MATCHES 10.9)
97   # make sure syslibs and headers are looked up in sdk ( especially for 10.9 openGL atm. )
98   set(CMAKE_FIND_ROOT_PATH ${CMAKE_OSX_SYSROOT})
99 endif()
100
101 # 10.9 is our min. target, if you use higher sdk, weak linking happens
102 if(CMAKE_OSX_DEPLOYMENT_TARGET)
103   if(${CMAKE_OSX_DEPLOYMENT_TARGET} VERSION_LESS 10.9)
104     message(STATUS "Setting deployment target to 10.9, lower versions are not supported")
105     set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "" FORCE)
106   endif()
107 else()
108   set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "" FORCE)
109 endif()
110
111 if(NOT ${CMAKE_GENERATOR} MATCHES "Xcode")
112   # force CMAKE_OSX_DEPLOYMENT_TARGET for makefiles, will not work else ( cmake bug ? )
113   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mmacosx-version-min=${CMAKE_OSX_DEPLOYMENT_TARGET}")
114   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=${CMAKE_OSX_DEPLOYMENT_TARGET}")
115   add_definitions("-DMACOSX_DEPLOYMENT_TARGET=${CMAKE_OSX_DEPLOYMENT_TARGET}")
116 endif()